  PROGRAM
  INCLUDE('Cstr.inc'),ONCE

PyObject        EQUATE(LONG)

  MAP
    MODULE('python35.dll')
      Py_Initialize(),LONG,RAW,C,NAME('Py_Initialize')
      PyRun_SimpleString(*CSTRING PyCode),LONG,PROC,RAW,C,NAME('PyRun_SimpleString')
      PyImport_AddModule(*CSTRING PyName),LONG,RAW,C,NAME('PyImport_AddModule')
      PyObject_GetAttrString(PyObject ObjectPtr, *CSTRING PyName),LONG,RAW,C,NAME('PyObject_GetAttrString')
      PyBytes_FromObject(PyObject ObjectPtr),LONG,RAW,C,NAME('PyBytes_FromObject')
      PyBytes_AsString(PyObject ObjectPtr),CSTRING,RAW,C,NAME('PyBytes_AsString')
      PyObject_Str(PyObject ObjectPtr),LONG,RAW,C,NAME('PyObject_Str')
      PyObject_Bytes(PyObject ObjectPtr),LONG,RAW,C,NAME('PyObject_Bytes')
      PyUnicode_AsUTF8(PyObject ObjectPtr),CSTRING,RAW,C,NAME('PyUnicode_AsUTF8')
      PyBytes_Size(PyObject ObjectPtr),LONG,RAW,C,NAME('PyBytes_Size')
      PyBytes_Check(PyObject ObjectPtr),LONG,RAW,C,NAME('PyBytes_Check')
      PyBytes_FromString(*CSTRING PyStr),LONG,PROC,RAW,C,NAME('PyBytes_FromString')
      Py_Finalize(),LONG,PROC,RAW,C,NAME('Py_Finalize')
    END
  END

PythonClass     CLASS,TYPE
Construct         PROCEDURE
Destruct          PROCEDURE
RunScript         PROCEDURE(STRING ScriptText),STRING
RunScript         PROCEDURE(*CSTRING ScriptText),STRING
RunFile           PROCEDURE(STRING FileName),STRING
                END

PY              PythonClass

  CODE
  MESSAGE(PY.RunScript('from time import time, ctime<13>print(''Today is'', ctime(time()))'))
  MESSAGE(PY.RunScript('print("   ")'))
  MESSAGE(PY.RunScript('print(1+1)'))
  MESSAGE(PY.RunFile('test.py'))
  MESSAGE(PY.RunFile('getfile.py')) !  index  google.ru


PythonClass.Construct       PROCEDURE
  CODE
  Err# = Py_Initialize()

PythonClass.Destruct        PROCEDURE
  CODE
  Py_Finalize()

PythonClass.RunScript       PROCEDURE(STRING ScriptText)!,STRING
txt                         Cstr
  CODE
  txt.Set(ScriptText)
  RETURN SELF.RunScript(txt.CStr())

PythonClass.RunScript       PROCEDURE(*CSTRING ScriptText)!,STRING
tcode                       CSTRING(100)
fcode                       Cstr
pmodule                     PyObject
catcher                     PyObject
output                      PyObject
txt                         Cstr
  CODE
  tcode = '__main__'
  pmodule = PyImport_AddModule(tcode)

  fcode.Cat('import sys<13>class CatchOut:<13>    def __init__(self):<13>        self.value = ''''<13>    def write(self, txt):<13>        self.value += txt<13>catchOut = CatchOut()<13>sys.stdout = catchOut<13>sys.stderr = catchOut')
  Err# = PyRun_SimpleString(fcode.CStr())

  txt.Cat(ScriptText)
  txt.ToUTF8()
  Err# = PyRun_SimpleString(txt.CStr())

  tcode = 'catchOut'
  catcher = PyObject_GetAttrString(pmodule, tcode)

  tcode = 'value'
  output = PyObject_GetAttrString(catcher, tcode)

  txt.Set(PyUnicode_AsUTF8(output))
  txt.ToASCII()
  RETURN txt.Str()

PythonClass.RunFile         PROCEDURE(STRING FileName)!,STRING
txt                         Cstr
  CODE
  txt.LoadFromFile(FileName)
  RETURN SELF.RunScript(txt.CStr())